import std.stdio;
import std.metastrings;

class IO {
    alias void delegate () DG;
    DG[] dgs;
    this(DG dg) {
        dgs ~= dg;
    }
    this(DG[] dgs0) {
        dgs = dgs0;
    }
    this() {}
}

class ThunkBase {}

class Thunk(T) : ThunkBase {
    this(T t0) {
        t = t0;
        done = true;
    }
    this(Thunk t0) {
        t = t0.t;
        dg = t0.dg;
        done = t0.done;
    }
    this(T delegate() dg0) {
        dg = dg0;
    }
    T opCall() {
        if (done) return t;
        done = true;
        return t = dg();
    }
    T t;
    T delegate() dg;
    bool done;
    static const bool is_thunk = true;
}

template ThunkType(T) {
    static if (is(T : ThunkBase)) {
        alias T ThunkType;
    }
    else static if (is(T R == return)) {
        alias Thunk!(R) ThunkType;
    }
    else {
        alias Thunk!(T) ThunkType;
    }
}

template thunk(T) {
    ThunkType!(T) thunk(T t) { return new ThunkType!(T)(t); }
}

unittest {
    auto a = thunk(1);
    int ai = a();
    auto b = thunk(a);
    int bi = b();
    auto c = thunk({});
}

template ctmangle_impl(const(char)[] n) {
    static if (n.length == 0) {
        const char[] ctmangle_impl = "";
    }
    else static if ((n[0] >= 'a' && n[0] <= 'z') ||
                    (n[0] >= 'A' && n[0] <= 'Z') ||
                    (n[0] >= '0' && n[0] <= '9') ||
                    (n[0] == '_')) {
        const char[] ctmangle_impl = n[0] ~ ctmangle_impl!(n[1..$]);
    }
    else {
        const char[] ctmangle_impl =
            "_" ~ ToString!(cast(int)n[0]) ~ ctmangle_impl!(n[1..$]);
    }
}

template mfunc(const(char)[] a, const(char)[] b, const(char)[] c) {
    const(char)[] mfunc = a ~ " _" ~ ctmangle_impl!(b) ~ c;
}

mixin mfunc!("string", "++", "(string a, string b) { return a~b; }");
mixin mfunc!("bool", "==", "(int a, int b) { return a==b; }");
mixin mfunc!("bool", "!=", "(int a, int b) { return a!=b; }");
mixin mfunc!("IO", ">>", "(IO a, IO b) { a.dgs ~= b.dgs; return a; }");

string ___43__43(Thunk!(string) a, Thunk!(string) b) {
    return a()~b();
}
int ___43(Thunk!(int) a, Thunk!(int) b) {
    return a()+b();
}
int ___45(Thunk!(int) a, Thunk!(int) b) {
    return a()-b();
}
bool ___61__61(Thunk!(int) a, Thunk!(int) b) {
    return a()==b();
}
bool ___60__61(Thunk!(int) a, Thunk!(int) b) {
    return a()<=b();
}
bool ___33__61(Thunk!(int) a, Thunk!(int) b) {
    return a()!=b();
}
IO ___62__62(Thunk!(IO) a, Thunk!(IO) b) {
    IO.DG[] dgs = a().dgs;
    dgs ~= b().dgs;
    return new IO(dgs);
}

IO _putStr(Thunk!(string) s) {
    return new IO({writef(s());});
}

IO _putInt(Thunk!(int) i) {
    return new IO({writef(i());});
}

int _mod(Thunk!(int) n, Thunk!(int) d) {
    return n() % d();
}

IO _return() {
    return new IO;
}

extern(C) IO _main();

void main() {
    IO io = _main();
    foreach (dg; io.dgs) {
        dg();
    }
}
