private import std.string;

public:

string tostr(string v) { return v; }
string tostr(char* v) { return std.string.toString(v); }
string tostr(ubyte* v) { return std.string.toString(cast(char*)v); }
string tostr(int v) {
    if (v < 0) {
        return "-" ~ std.string.toString(-v);
    }
    else {
        return std.string.toString(v);
    }
}
string tostr(uint v) { return std.string.toString(v); }
string tostr(long v) {
    if (v < 0) {
        return "-" ~ std.string.toString(-v);
    }
    else {
        return std.string.toString(v);
    }
}
string tostr(ulong v) { return std.string.toString(v); }
string tostr(bit v) { return std.string.toString(v); }
string tostr(float v) {
    return format("%f", v);
}
string tostr(double v) {
    return format("%f", v);
}
string tostr(Object v) { return v.toString(); }

version (Test) {
    int main() {
        init();

        assert("1" == tostr(1));
        assert("-1" == tostr(-1));
        assert("0.100000" == tostr(0.1f));
        assert("0.200000" == tostr(0.2));
        assert("0" == tostr(false));
        assert("1" == tostr(true));

        uint hoge = 2;
        assert("2" == tostr(hoge));

        return 0;
    }
}
